---
title: Atomics.sub()
slug: Web/JavaScript/Reference/Global_Objects/Atomics/sub
tags:
  - Atomics
  - JavaScript
  - Method
  - Shared Memory
---
<div>{{JSRef}}</div>

<p>The static <strong><code>Atomics.sub()</code></strong> method substracts a given value at a given position in the array and returns the old value at that position. This atomic operation guarantees that no other write happens until the modified value is written back.</p>

<div>{{EmbedInteractiveExample("pages/js/atomics-sub.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Atomics.sub(<var>typedArray</var>, <var>index</var>, <var>value</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>typedArray</var></code></dt>
 <dd>An integer typed array. One of {{jsxref("Int8Array")}}, {{jsxref("Uint8Array")}}, {{jsxref("Int16Array")}}, {{jsxref("Uint16Array")}}, {{jsxref("Int32Array")}}, {{jsxref("Uint32Array")}}, {{jsxref("BigInt64Array")}}, or {{jsxref("BigUint64Array")}}.</dd>
 <dt><code><var>index</var></code></dt>
 <dd>The position in the <code><var>typedArray</var></code> to subtract a <code><var>value</var></code> from.</dd>
 <dt><code><var>value</var></code></dt>
 <dd>The number to subtract.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The old value at the given position (<code><var>typedArray</var>[<var>index</var>]</code>).</p>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>Throws a {{jsxref("TypeError")}}, if <code><var>typedArray</var></code> is not one of the allowed integer types.</li>
 <li>Throws a {{jsxref("RangeError")}}, if <code><var>index</var></code> is out of bounds in the <code><var>typedArray</var></code>.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Using_sub">Using sub</h3>

<pre class="brush: js notranslate">const sab = new SharedArrayBuffer(1024);
const ta = new Uint8Array(sab);
ta[0] = 48;

Atomics.sub(ta, 0, 12); // returns 48, the old value
Atomics.load(ta, 0); // 36
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-atomics.sub', 'Atomics.sub')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Atomics.sub")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Atomics")}}</li>
 <li>{{jsxref("Atomics.add()")}}</li>
</ul>
